<?php
	require ('parsecommands.php');

	/*** Global variables. ***/
	$global_refs_array = array();
	$global_n = 0;
	$global_id = 0;
	$global_tosend = array();
	$global_disable_ids = array();
	$global_fileidlist = array();
	$global_fileidlist_f = array();

/***********************************************/
function print_form ($info, $level)
/***********************************************/
{
	$level++;
	$i = 0;

	while ($hack = @$info[$i++])
	{
		$attr = $hack['attributes'];
		if ($hack['name'] == 'folder')
		{
			echo "<h" . $level . ">\nFolder " . $attr['name'] .
				"</h" . $level . ">\n";
			echo "<div class='hc4'>\n";
			print_form ($hack['children'], $level);
			echo "</div>\n";
		} else {
			echo "<h" . $level . ">\nSet up " . $attr['name'] .
				"</h" . $level . ">\n";
			echo "<div class='hc5'>\n";
			if ($help = @$hack['attributes']['help'])
			{
				echo "<p class='helptip'>\n" . $help . "</p>\n";
			}
			print_hack ($hack['children']);
			echo "</div>\n";
		}
	}
}
/***********************************************/
function create_ref ($name, $id)
/***********************************************/
{
	$ref = $name . '_' . $id;
	global $global_refs_array, $global_n;

	if ($r = @$global_refs_array[$ref])
		return $r;

	$global_refs_array[$ref] = "f" . $global_n;
	$global_n++;

	return ($global_refs_array[$ref]);
}
/***********************************************/
function get_free_id ()
/***********************************************/
{
	global $global_id;

	return ($global_id++);
}
/***********************************************/
function process_action (&$item, &$thereareoffsets, &$binary, &$i,
	&$refid, $level, $gname, &$offsets, $total)
/***********************************************/
{
	switch ($item['name'])
	{
		case 'offset':
			if (!$thereareoffsets)
			{
				$offsets = array();
				$thereareoffsets = true;
			}
			$offsets[$item['attributes']['file']] = $item['attributes']['value'];
			break;
		case 'check':
			if ($thereareoffsets)
			{
				$binary[] = array ('action'=>'offset', 'info'=>$offsets);
				$thereareoffsets = false;
			}

			$binary[] = array ('action'=>'check',
				'codes'=>$item['attributes']['codes']);
			break;
		case 'read':
			if ($thereareoffsets)
			{
				$binary[] = array ('action'=>'offset', 'info'=>$offsets);
				$thereareoffsets = false;
			}

			if ($dup = @$item['attributes']['duplicated'])
			{
				$binary[] = array ('action'=>'duplicate',
					'reference'=>create_ref($dup, $refid),
					'wop'=>@$item['attributes']['writeoperation'],
					'type'=>@$item['attributes']['type']);
			} else {
				$binary[] = array ('action'=>'read',
					'type'=>$item['attributes']['type'],
					'reference'=>create_ref($item['attributes']['name'], $refid),
					'wop'=>@$item['attributes']['writeoperation'],
					'size'=>@$item['attributes']['size']);
				print_input ($item['attributes'], $refid, @$item['children'],
					$offsets, $gname, $i, $level, $total);
			}
			break;
		case 'group':
			$j = 0;
			while ($item2 = @$item['children'][$j++])
			{
				process_action ($item2, $thereareoffsets, $binary, $j, $refid,
					$level + 1, $item['attributes']['name'], $offsets,
					count ($item['children']));
			}
			break;
	}
}
/***********************************************/
function print_hack ($hack)
/***********************************************/
{
	/*** first: separate the offsets and versions availables ***/
	/*** and the reading algorithm ***/
	global $global_tosend;
	$refid = get_free_id();
	$i = 0;
	$thereareoffsets = false;
	$binary = array();
	$level = 0;

	while ($item = @$hack[$i++])
	{
		process_action ($item, $thereareoffsets, $binary, $i, $refid,
			$level, 'main', $offsets, count ($hack));
	}

	$global_tosend[$refid] = $binary;
}
/***********************************************/
function print_input ($read, $refid, $extra, $offsets, $gname,
	$i, $level, $total)
/***********************************************/
{
	$type = @$read['type'];
	$name = @$read['name'];
	$use = @$read['use'];
	$default = @$read['default'];
	$minval = @$read['minval'];
	$maxval = @$read['maxval'];
	$desc = @$read['help'];
	$readoperation = @$read['readoperation'];

	$from = ($minval && $maxval) ? " (from " . $minval .
		" to " . $maxval . ")" : '';
	if ($default && $readoperation)
		parse_commands ($readoperation, $default);
	$def = $default !== false ? "value='" . $default . "'" : '';
	$ref = create_ref ($name, $refid);
	$pname = ucfirst ($name);
	$gname = ucfirst ($gname);
	$tip = $desc ? "<p class='helptip'>\n" . str_replace
		('http://popuw.com/forum/viewtopic.php?t=557',
		'http://forum.princed.org/', $desc) . "</p>\n" : '';

	$size = @$read['size'];
	$maxlength = $size ? " maxlength='" . $size . "'" : '';
	$def .= $maxlength;

	if ($use == 'checkbox')
	{
		/*** Used to be: $def = $default ? "checked='checked' " : ''; ***/
		$def = "checked='checked' ";
		if ($level) /*** it is grouped ***/
		{
			if ($i == 1)
				echo "<div class='black'>\n<p>\n<label>\n" . $gname .
					":</label>\n<span class='inputblock'>\n";
			echo "<input name='" . $ref . "' type='checkbox' value='1' title='" .
				$pname . "' " . $def . "/>\n";
			if ($i == $total)
				echo "</span>\n</p>\n</div>\n";
		} else {
			echo "<div class='black'>\n<p>\n<label>\n" . $pname .
				":</label>\n<input name='" . $ref . "' type='checkbox' value='1' " .
				$def . "/>\n</p>\n" . $tip . "</div>\n";
		}
	} else if (@$extra[0]) { /*** cool it is a combo box ***/
		$i = 0;
		echo "<div class='black'>\n<p>\n<label>\n" . $pname .
			":</label>\n<select name='" . $ref . "' class='nonblocked'>\n";
		while ($option = @$extra[$i++])
		{
			$value = @$option['attributes']['value'];
			$content = $option['content'];
			$default = @$option['attributes']['default'];

			$v = !is_null ($value) ? " value='" . $value . "'" : '';
			$d = $default ? " selected='selected'" : '';
			echo "<option" . $v . $d . ">\n" . str_replace ('<', '&lt;', $content) .
				"</option>\n";
		}
		echo "</select>\n</p>\n" . $tip . "</div>\n";
	} else {
		if ($level) /*** it is grouped ***/
		{
			if ($i == 1)
				echo "<div class='black'>\n<p>\n<label>\n" .
					$gname . ":</label>\n<span class='inputblock'>\n";
			echo "<input name='" . $ref . "' type='text' class='inputblocktext' " .
				"title='" . $pname . "' " . $def . "/>\n";
			if ($i == $total)
				echo "</span>\n</p>\n</div>\n";
		} else {
			echo "<div class='black'>\n<p>\n<label>\n" . $pname .
				":</label>\n<input name='" .
				$ref . "' type='text' class='nonblocked' " . $def . "/>\n" .
				$from . "</p>\n" . $tip . "</div>\n";
		}
	}

	add_field ($offsets, $ref);
}
/***********************************************/
function xml_to_object ($xml)
/***********************************************/
{
	$parser = xml_parser_create();
	xml_parser_set_option ($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option ($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct ($parser, $xml, $tags);
	xml_parser_free ($parser);

	$elements = array();
	$stack = array();
	foreach ($tags as $tag)
	{
		$index = count ($elements);
		if (($tag['type'] == "complete") || ($tag['type'] == "open"))
		{
			$elements[$index] = array();
			$elements[$index]['name'] = $tag['tag'];
			$elements[$index]['attributes'] = @$tag['attributes'];
			$elements[$index]['content'] = @$tag['value'];
			if ($tag['type'] == "open")
			{
				$elements[$index]['children'] = array();
				$stack[count ($stack)] = &$elements;
				$elements = &$elements[$index]['children'];
			}
		}
		if ($tag['type'] == "close")
		{
			$elements = &$stack[count ($stack) - 1];
			unset ($stack[count ($stack) - 1]);
		}
	}

	return ($elements[0]);
}
/***********************************************/
function add_field ($offsets, $ref)
/***********************************************/
{
	global $global_fileidlist, $global_disable_ids, $global_fileidlist_f;

	$r = $global_fileidlist;
	foreach ($offsets as $file=>$v)
	{
		unset ($r[$global_fileidlist_f[$file]]);
	}

	$global_disable_ids[$ref] = $r;
}
/***********************************************/
function print_script ()
/***********************************************/
{
	global $global_fileidlist, $global_disable_ids, $global_n;

	$comma = '';
	$all = '';
	for ($i = 0; $i < $global_n; $i++)
	{
		$all1 = "f" . $i;
		$all .= $comma . "z." . $all1;
		$comma = ',';
	}

	$comma = '';
	$l = '';
	for ($i = 0; $i < $global_n; $i++)
	{
		$comma2 = '';
		$l2 = '';
		$val = @$global_disable_ids["f" . $i];
		foreach ($val as $j=>$l3)
		{
			$l3 = @$val[$j];
			$l2 .= $comma2 . "'" . $l3 . "'";
			$comma2 = ',';
		}
		$l .= $comma . "new Array($l2)";
		$comma = ',';
	}

print ("
<script type='text/javascript'>
<!--
	var z = document.fr;
	all = new Array($all);
	var l = new Array($l);

	function x() {
		var a = document.fr.file.value;
		var l2 = l[a];
		for (j = 0; j < $global_n; j++)
		{
			all[j].disabled = false;
			for (i = 0; i < l[j].length; i++)
			{
				if (l[j][i] == a) all[j].disabled = true;
			}
		}
	}
//-->
</script>
");
}
/***********************************************/
function print_page ()
/***********************************************/
{
	global $global_fileidlist, $global_fileidlist_f, $global_tosend;

	$tree = xml_to_object (file_get_contents ("princehack.xml"));

	if ($tree['name'] != 'princehack')
		die ('main tag is not princehack');
	if ($tree['children'][0]['name'] != 'files')
		die ('where are the files?');
	$filelist = $tree['children'][0]['children'];

	/*** begin form ***/
	echo "<form method='post' action='gethack.php' name='fr'>\n<div id='form'>\n";
	echo "<h2>\nPreface</h2>\n<div class='just'>\n<p>\nThis page allows you to download the file with the customizations you select in the form. By default the values are set as the original game (except for the \"Set up allowed resources per level\", that have all been enabled). Refer to the XML specification for technical information or visit the hex editing thread in the forum for the credits, to contribute, get support and/or add suggestions. If you suggest a new hack, please take a look at the format generator to ensure we are using the same language and file versions.</p>\n</div>\n";

	/*** draw versions ***/
	echo "<h2>\nChoose your file</h2>\n<div class='hc4'>\n<p>\n" .
		"<label>\nChoose the file you want:</label>\n ";
	$i = 0;
	echo "<select name='file' onchange='x();' class='nonblocked'>\n";

	while ($file = @$filelist[$i++])
	{
		$file = $file['attributes'];
		$def = @$file['default'];
		$def = $def ? ' selected="selected"' : '';
		echo "<option value='" . $file['name'] . "'" . $def . ">\n" .
			$file['path'] . " " . $file['version'] . "</option>\n";
		$global_fileidlist[] = $file['name'];
	}
	$global_fileidlist_f = array_flip ($global_fileidlist);
	echo "</select>\n</p>\n</div>\n";

	/*** draw folders ***/
	$hacks = $tree['children'][1]['children'];
	if ($tree['children'][1]['name'] != 'hacks')
		die ('where are the hacks?');
	print_form ($hacks, 1);

	/*** draw hidden ***/
	$pass = base64_encode (serialize ($global_tosend));
	$verify = md5 ($pass . 'mega_hit_34');
	echo "</div>\n<div class='center'>\n<input type='hidden' name='pass'" .
		" value='" . $pass . "' />\n<input type='hidden' name='verify'" .
		" value='$verify' />\n";

	/*** end form ***/
	echo "<input type='submit' value='Get the file' />\n</div>\n</form>\n";
}
/***********************************************/

	print_page();
	print_script();
?>
